﻿using ProjectTank.Entities;

namespace ProjectTank
{
    /// <summary>
    /// Класс-сущность танк
    /// </summary>
    public class EntityBattleTank : EntityTank

    {
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color AdditionalColor { get; private set; }

        /// <summary>
        /// Признак (опция) наличия пушки 
        /// </summary>
        public bool Gun { get; private set; }


        /// <summary>
        /// Признак (опция) наличия Пулемета на башне
        /// /// </summary>
        public bool MachinGun { get; private set; }

        public void SetAdditionalColor(Color addColor)
        {
            AdditionalColor = addColor;
        }

        /// <summary>
        /// Конструктор объекта-класса Боевого Танка
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="gun">Пушка танка</param>
        /// <param name="machinGun">Пклемет на башне</param>
        public EntityBattleTank(int speed, double weight, Color bodyColor, Color additionalColor, bool gun, bool machinGun) : base(speed, weight, bodyColor)
        {
            AdditionalColor = additionalColor;
            MachinGun= machinGun;
            Gun = gun;
        }

    }
}
